<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="8" :lg="8" :xl="8">
          <v-row>
            <v-col :cols="12" :sm="12" :md="8" :lg="8" :xl="5">
              <v-autocomplete
                v-model="graficaSemaforo.semaforo"
                :items="semaforos"
                :loading="isLoadingSemaforos"
                flat
                label="Semáforo"
                item-text="descripcion"
                item-value="idSemaforo"
                return-object
              >
                <template v-slot:selection="data">
                  <v-chip
                    v-bind="data.attrs"
                    :input-value="data.selected"
                    close
                    small
                    @click="data.select"
                    @click:close="graficaSemaforo.semaforo = null"
                  >
                    {{ data.item.descripcion }}
                  </v-chip>
                </template>
                <template v-slot:item="data">
                  <v-list-item-content>
                    <v-list-item-title>
                      {{ data.item.descripcion }}
                    </v-list-item-title>
                    <v-list-item-subtitle>
                      <v-rating
                        :length="data.item.rangos.length"
                        :value="data.item.rangos.length"
                        readonly
                      >
                        <template v-slot:item="props" z>
                          <v-icon
                            class="pa-0"
                            :color="
                              props.isFilled
                                ? data.item.rangos[props.index].color
                                : 'grey lighten-1'
                            "
                            @click="props.click"
                          >
                            {{
                              props.isFilled
                                ? "mdi-circle"
                                : "mdi-circle-outline"
                            }}
                          </v-icon>
                        </template>
                      </v-rating>
                    </v-list-item-subtitle>
                  </v-list-item-content>
                </template>
              </v-autocomplete>
            </v-col>
            <v-col :cols="12" :sm="12" :md="8" :lg="8" :xl="5">
              <v-text-field
                flat
                v-model.trim="graficaSemaforo.regla"
                maxlength="50"
                :error="$v.graficaSemaforo.regla.error"
                hint-align="right"
                :hint="
                  'CARACTERES RESTANTES ' +
                    serviceCommons.remaningCharacters(graficaSemaforo.regla, 50)
                "
                label="Regla"
              >
                <template v-if="$v.graficaSemaforo.regla.$error" v-slot:append>
                  <v-popover placement="bottom-end" color="red" offset="16">
                    <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                    <template slot="popover">
                      <div
                        @click="$v.graficaSemaforo.regla.$reset"
                        v-close-popover
                      >
                        <div v-if="!$v.graficaSemaforo.regla.required">
                          ¡No te olvides de éste campo!
                        </div>
                      </div>
                    </template>
                  </v-popover>
                </template>
              </v-text-field>
            </v-col>
            <v-col :cols="12" :sm="12" :md="8" :lg="8" :xl="2">
              <v-btn
                class="mt-3"
                :class="[{ desac: this.$v.$invalid }]"
                depressed
                dark
                tile
                block
                color="primary"
                @click="postSemaforoGrafica"
                >Asociar</v-btn
              >
            </v-col>
          </v-row>
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchGraficaSemaforos"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
              <v-progress-linear
                :active="isLoadingGraficaSemaforos"
                :indeterminate="isLoadingGraficaSemaforos"
                absolute
                bottom
                color="primary"
              />
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader style="position : relative;">
                SEMÁFOROS ASOCIADOS A LA GRÁFICA
                <v-btn
                  style="top:10px;"
                  color="primary"
                  fab
                  dark
                  small
                  absolute
                  top
                  right
                  @click="getGraficaSemaforos"
                >
                  <v-icon color="white">mdi-sync</v-icon>
                </v-btn>
              </v-subheader>
              <v-list-item-group
                v-model="selectedGraficaSemaforos"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedGraficaSemaforos"
                  :key="indexItem"
                >
                  <template v-slot:default="{}">
                    <v-list-item-avatar>
                      <v-icon large>mdi-traffic-light</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-subtitle v-text="item.regla" />
                      <v-list-item-title>
                        {{ item.semaforo.descripcion }}
                      </v-list-item-title>
                      <v-list-item-subtitle>
                        <v-rating
                          :length="item.semaforo.rangos.length"
                          :value="item.semaforo.rangos.length"
                          readonly
                        >
                          <template v-slot:item="props" z>
                            <v-icon
                              class="pa-0"
                              :color="
                                props.isFilled
                                  ? item.semaforo.rangos[props.index].color
                                  : 'grey lighten-1'
                              "
                              @click="props.click"
                            >
                              {{
                                props.isFilled
                                  ? "mdi-circle"
                                  : "mdi-circle-outline"
                              }}
                            </v-icon>
                          </template>
                        </v-rating>
                      </v-list-item-subtitle>
                    </v-list-item-content>
                    <v-list-item-action>
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            class="white--text"
                            color="grey"
                            v-bind="attrs"
                            v-on="on"
                            @click="deleteItem(item)"
                          >
                            <v-icon>mdi-delete-sweep</v-icon>
                          </v-btn>
                        </template>
                        <span>Desasociar de la grafica</span>
                      </v-tooltip>
                    </v-list-item-action>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
    <template>
      <v-dialog v-model="isDialogDelete" persistent max-width="610px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh...! </strong>
            Desasociar semáforo. Estas totalmente seguro?
            <v-icon right color="orange">mdi-alert</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p v-if="editedItem.regla">
              Para confirmar esta acción por favor escribe:
              <br />
              <em
                ><code>{{ editedItem.regla }}</code></em
              >
            </p>
            <v-text-field
              v-model="confirmText"
              :autofocus="true"
              label="Confirma con el nombre de la regla"
              flat
              class="mr-2 ml-2"
            />
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="closeDelete"
                >No, cancelar</v-btn
              >
              <v-btn
                :class="[
                  {
                    desac: !(
                      editedItem.regla && confirmText == editedItem.regla
                    ),
                  },
                ]"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteItemConfirm"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Semaforos",
  props: ["graficaIn"],
  data() {
    return {
      isDialogDelete: false,
      isLoadingSemaforos: false,
      isLoadingGraficaSemaforos: false,
      searchGraficaSemaforos: null,
      selectedGraficaSemaforos: null,
      data: [],
      grafica: null,
      semaforos: [],
      defaultGraficaSemaforo: {
        semaforo: {},
        regla: null,
      },
      graficaSemaforo: {
        semaforo: {},
        regla: null,
      },
      confirmText: null,
      editedIndex: -1,
      editedItem: {
        semaforo: {},
        regla: null,
      },
    };
  },
  validations: {
    graficaSemaforo: {
      semaforo: {
        required,
      },
      regla: {
        required,
        unique: function(val) {
          return (
            !this.data.filter(
              (graficaSemaforo) => graficaSemaforo.regla === val
            ).length > 0
          );
        },
      },
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedGraficaSemaforos() {
      let tempData = this.data;
      if (this.searchGraficaSemaforos != "" && this.searchGraficaSemaforos) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchGraficaSemaforos.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.regla.toLowerCase();
          let fb = b.regla.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  watch: {
    isDialogDelete(val) {
      if (!val) {
        this.closeDelete();
      }
    },
  },
  methods: {
    toSemaforo(semaforo) {
      return {
        name: "sistema_informacion_dashboard_v2_semaforos_edicion",
        params: {
          semaforo: this.serviceCommons.objectToBase64(semaforo),
        },
      };
    },
    deleteSemaforoGrafica() {
      axios
        .delete(
          "/sistema-informacion/tablero/graficas/v1/" +
            this.grafica.idGrafica +
            "/semaforos/" +
            this.editedItem.semaforo.idSemaforo +
            "?regla=" +
            this.editedItem.regla
        )
        .then((response) => {
          this.data.splice(this.indexItem, 1);
          this.closeDelete();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.isDialogDelete = true;
    },
    deleteItemConfirm() {
      this.deleteSemaforoGrafica();
    },
    closeDelete() {
      this.isDialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultGraficaSemaforo);
        this.editedIndex = -1;
        this.confirmText = null;
      });
    },
    postSemaforoGrafica() {
      let body = {
        idSemaforo: this.graficaSemaforo.semaforo.idSemaforo,
        regla: this.graficaSemaforo.regla,
      };
      axios
        .post(
          "/sistema-informacion/tablero/graficas/v1/" +
            this.grafica.idGrafica +
            "/semaforos",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.graficaSemaforo.idGraficaSemaforo = data.resultado.id;
            this.data.push(JSON.parse(JSON.stringify(this.graficaSemaforo)));
            this.graficaSemaforo = Object.assign(
              {},
              this.defaultGraficaSemaforo
            );
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getSemaforos() {
      this.isLoadingSemaforos = true;
      axios("/sistema-informacion/tablero/semaforos/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            this.semaforos = data.resultado.semaforos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.semaforos = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingSemaforos = false;
          this.semaforos.forEach((semaforo) => {
            this.getSemaforoRangos(semaforo);
          });
        });
    },
    getSemaforo(graficaSemaforo) {
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" +
          graficaSemaforo.semaforo.idSemaforo
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            graficaSemaforo.semaforo = {
              ...graficaSemaforo.semaforo,
              ...data.resultado,
              rangos: [],
            };
            this.getSemaforoRangos(graficaSemaforo.semaforo);
          }
        })
        .catch((error) => {});
    },
    getSemaforoRangos(semaforo) {
      this.isLoadingSemaforos = true;
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" +
          semaforo.idSemaforo +
          "/rangos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            semaforo.rangos = data.resultado.rangos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            semaforo.rangos = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingSemaforos = false;
        });
    },
    getGraficaSemaforos() {
      this.isLoadingGraficaSemaforos = true;
      axios(
        "/sistema-informacion/tablero/graficas/v1/" +
          this.grafica.idGrafica +
          "/semaforos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = data.resultado.semaforos.map((graficaSemaforo) => {
              let semaforo = {
                idSemaforo: graficaSemaforo.idSemaforo,
                rangos: [],
              };
              return {
                semaforo,
                regla: graficaSemaforo.regla,
              };
            });
            this.data = this.data.map((graficaSemaforo) => {
              this.getSemaforo(graficaSemaforo);
              return graficaSemaforo;
            });
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingGraficaSemaforos = false;
        });
    },
  },
  created() {
    this.grafica = this.graficaIn;
    this.getSemaforos();
    this.getGraficaSemaforos();
  },
};
</script>
